<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Copying the Objects</TITLE>
<link href="suif1_89.html" rel=Next>
<link href="suif1_87.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_87.html">previous</A>, <A HREF="suif1_89.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC88" HREF="suif1_toc.html#TOC88">Copying the Objects</A></H2>

<P>
<A NAME="IDX641"></A>
<A NAME="IDX642"></A>
<A NAME="IDX643"></A>
<A NAME="IDX644"></A>
<A NAME="IDX645"></A>
<A NAME="IDX646"></A>
Once the exposed references have been resolved, the code can be copied.
The <CODE>tree_node_list</CODE>, <CODE>tree_node</CODE>, <CODE>operand</CODE>,
<CODE>instruction</CODE>, <CODE>block_symtab</CODE>, and <CODE>proc_symtab</CODE> classes
have <CODE>clone_helper</CODE> methods to perform the actual copying.  These
methods change references to objects in the original objects lists of
the <CODE>replacements</CODE> structure to references to the newly created
replacements.

</P>
<P>
<A NAME="IDX647"></A>
Annotations on the objects are also cloned.  The <CODE>clone_annotes</CODE>
method is used to copy the annotations from one <CODE>suif_object</CODE> to
another.  Unregistered annotations cannot be copied because the
structure of their data fields is unknown.  The <CODE>clone_helper</CODE>
methods call <CODE>clone_annotes</CODE> for each object that is cloned; you
generally do not need to call it directly.

</P>
<P>
The <CODE>clone_helper</CODE> and <CODE>clone_annotes</CODE> methods can also be
used to perform another related function.  It is occasionally necessary
to replace references to one set of objects with references to another
set of objects.  Since the cloning methods do that anyway, it is easy to
have them update the references without actually making copies.  Setting
the <CODE>no_copy</CODE> parameter causes them to update the references as
specified in a <CODE>replacements</CODE> structure without copying the
objects.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_87.html">previous</A>, <A HREF="suif1_89.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
